//***********************************************
//*                 Main.C                      *
//***********************************************
//*
//*			  		  mߤ

//* Ū TC74-A7 P TC1047A ӤPAū׷P
//* ñNഫ10i ASCII ,ܦb LCD ܹ
//*
//*  1. T1 Ʀ즡ūסAd򬰨
//*  2. T2 񦡷ūסAd xx.x
//*  3. QTimer1pɡACj 500mS sܪū
//*  4. ק Rec_Tmp.C ŪTū׭
//*  5. ק Timer1 _{AͥT500mSp
          	   
#include "main.h"

#pragma config OSC=HS, WDT=OFF, BOREN = ON, BORV = 1, LVP=OFF, PBADEN=OFF, XINST = OFF, MCLRE = ON

//*           wqܼƨéb Access Bank          
//*********************************************************** 
#pragma udata access My_RAM_1

near unsigned char Str_Len;
near unsigned char i;
near unsigned int T2_Buffer ;

near union
{
	int	Word ;
	unsigned char Byte[2] ;
}Byte2Word ;

near struct
{
	unsigned Timer1_Flag:1;
}Flagbits;

#pragma udata

char ASCII_String[10];

//*           wqLCDܪdréb ROM 
//     
//*********************************************************** 
#pragma romdata RomData
const rom char LCD_ROM_MSG1[ ] ="Lab 5 Read Temp.";
const rom char LCD_ROM_MSG2[ ] ="T1=    ";
const rom char LCD_ROM_MSG3[ ] ="T2=      ";
 
#pragma code

//*           wq`Ƹ    
//*********************************************************** 
// (1/32768Hz) * 16384 = 0.5 Sec
#define		Timer_Count		16384				// Set for 500mS @32.768KHz 

//***********************************************************
/*														   											*/
/* 						Main 	Program					   								*/
/*														   											*/
//***********************************************************
void main(void)
{
	InitializePORT( );
	InitializeINTs( );
	InitializeAD( );
 	InitializeTMR1( );
    Initialize_I2C_Master( );

	OpenLCD( );
	LCD_Set_Cursor(0,0);
	putrsLCD(LCD_ROM_MSG1);			// Display "Lab 5 Read Temp." on Line 1
 	LATD=0;
	Flagbits.Timer1_Flag = 1;		// }ɡAiHW LCD_Temp_Update ܷū
									// Kn Timer1  Time-Out ~ܪ
	while(1)
	{
 
		if (Flagbits.Timer1_Flag)	// update Temperature on LCD every 0.5 Sec
		{
			Flagbits.Timer1_Flag=0;
			LCD_Temp_Update ( ) ;	// update Temperature

			LATD = LATD<<1;			// PORTD LED Vk@
			if (!LATD) LATD = 0x01;	
		}
 	} 
}
 
//***************************************************
//*    The function will update the T1 & T2 on LCD 	*
//***************************************************
//*          Display LCD format on Line 1  			*
//* " T1=20* T2=101.8* " with auto position scaling *
//***************************************************
void LCD_Temp_Update (void)
{
	// ŪI2C ūפ TC74-A7 
	//*** Display TC74-A7 Temperature on LCD  ***
	LCD_Set_Cursor(1,0);
	putrsLCD(LCD_ROM_MSG2);							// Display "T1=   "

	LCD_Set_Cursor(1,3);					
	Byte2Word.Word = (Read_TC74_Temperature( )+2);  // Get Current Temperature form TC74-A7
													// [GOū׻~tץ([2)	
	if ( Byte2Word.Byte[1] == 0 )					// I2C `^
	{
		btoa(Byte2Word.Byte[0],ASCII_String);		// Convert Temp. Hax to ASCII string
  		putsLCD(ASCII_String);						// Print to LCD

		putcLCD(0xDF);							 	// Add degree symbol
	}
 	else if ( Byte2Word.Byte[1] == -1 )				// Read fail from TC74-A7, Display "--" on LCD
  	{
		putcLCD('-') ;		
		putcLCD('-') ;
	}

	// Ū񦡷ū׾ TC1047A
	//**** Display TC1047A Temperature on LCD  ***
	LCD_Set_Cursor(1,7);
	putrsLCD(LCD_ROM_MSG3);							// DIsplay "T2=    "

	LCD_Set_Cursor(1,10);					 
	T2_Buffer=Read_TC1047_Temperature( ) ;			// Get Current Temperature from TC1047A
	if (T2_Buffer==0) putcLCD('0');					// n 0 סA T2=0
	else
	{
//*****************************************
//*      ūഫ ASCII
//* 1. QC18ҴѪưഫ
//* 2. pI[JASCIIrꪺ
//* 3. for jppIm
//*****************************************
		itoa(T2_Buffer,ASCII_String);				// Convert to ASCII string
		Str_Len = strlen(ASCII_String);				// Get length for the ASCII-String
	
		for (i=0;i<Str_Len;i++)	//???					// ˬdūתr		
		{
			if (i==(Str_Len-1))	//???					// XpImA˼Ƥ@Ƥe
			{
				if (Str_Len==1) putcLCD('0'); //???		// ūקC@סAbe '0'  0.nת
				putcLCD('.');	//???			 		// [JpI
			}
			putcLCD(ASCII_String[i]);					// L@Ӧr LCD WA^hˬdr

		}
	}		
	putcLCD(0xDF);									// Add degree symbol
}

//************************************************
//* Function: isr_low(void)                      *     
//*  - Timer 1 Interrupt for the 500mS Delay     *
//*    for update VT100 terminal				 *            
//************************************************
#pragma interrupt isr_low 

void isr_low(void)
{
//*************************************
//*     Timer1 ]w
//* Timer1sJ500mS_pɭ
//* MTimer1_X
//*************************************

		WriteTimer1(65536-Timer_Count);				// Reload 0.5 Second value to Timer1
		PIR1bits.TMR1IF=0;							// Clear interrupt flag of Timer 1

		Flagbits.Timer1_Flag=1;						// Set for program task 
}								
#pragma code

//************************************************
//* Function: isr_low_direct                    *
//*   - Direct execution to the actual           *
//*     low-priority interrupt code.            *
//************************************************
//
// T]wCץv_Vqಾ
//
//??? #pragma code ???

void isr_low_direct(void)	
{  								
//???     ??? 				//begin in-line assembly
//???     ???				//go to isr_high function
//???     ???				//end in-line assembly
}
#pragma code


